package cn.rankin.apiweb.assist.resolver;

import cn.rankin.data.api.app.vo.DeviceUserVo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.MethodParameter;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.support.WebDataBinderFactory;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.context.request.WebRequest;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.method.support.ModelAndViewContainer;

/**
 * @author Tomas
 * @date 2016-07-17
 * @what
 */
@Component
public class NeedUserResolver implements HandlerMethodArgumentResolver {

    private static final Logger logger = LoggerFactory.getLogger(NeedUserResolver.class);

    public boolean supportsParameter(MethodParameter methodParameter) {
        return  methodParameter.hasParameterAnnotation(NeedUser.class);
    }

    public Object resolveArgument(MethodParameter methodParameter, ModelAndViewContainer modelAndViewContainer, NativeWebRequest nativeWebRequest, WebDataBinderFactory webDataBinderFactory) throws Exception {
        logger.info(String.format("Resolve argument %s.", methodParameter.getParameterName()));
        if(methodParameter.hasParameterAnnotation(NeedUser.class)){
            DeviceUserVo deviceUserVo = (DeviceUserVo) nativeWebRequest.getAttribute("RANKIN_DEVICE_USER_INFO", WebRequest.SCOPE_REQUEST);
            return deviceUserVo;
        }
        return null;
    }
}
