package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.code.ApiWebCode;
import cn.rankin.apiweb.service.event.EventService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.app.vo.DeviceUserVo;
import cn.rankin.data.api.user.dto.EventLogDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * CallbackController
 * Created by huodongdong on 2017/10/27.
 */
@RestController
@RequestMapping(value = "/callback")
public class CallbackController {

    @Autowired
    private EventService eventService;

    @RequestMapping(value = "/event", method = RequestMethod.POST)
    public APIResult<Boolean> addEvent(@NeedUser DeviceUserVo user, @RequestBody EventLogDTO eventLog) {
        if (eventLog.getEventType() == null ) {
            return APIResult.error(ApiWebCode.PARAMETER_ERROR);
        }

        eventLog.setMerchantId(user.getMerchantId());
        eventLog.setUserId(user.getUid());

        APIResult<Boolean> result = eventService.addLog(eventLog);
        return result;
    }
}

