package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.service.shopcart.ShopCartService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.dto.GoodsDTO;
import cn.rankin.data.api.app.vo.DeviceUserVo;
import cn.rankin.data.api.app.vo.GoodsVo;
import cn.rankin.data.api.user.dto.ShopCartDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/user/shopcart")
public class ShopCartController {

    @Autowired
    private ShopCartService shopCartService;

    @RequestMapping(value = "/totalNum", method = RequestMethod.GET)
    public APIResult getTotalNum(@NeedUser DeviceUserVo user) {
        return shopCartService.getTotalNum(user.getUid());
    }

    @RequestMapping(method = RequestMethod.GET)
    public APIResult<Page<GoodsVo>> getPage(@NeedUser DeviceUserVo user, @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer paegSize) {
        String userId = user.getUid();
        String merchantId = user.getMerchantId();
        return shopCartService.getPage(userId, merchantId, pageNo, paegSize);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Boolean> add(@NeedUser DeviceUserVo user, @RequestBody ShopCartDTO shopCartDTO) {
        String userId = user.getUid();
        String goodsId = shopCartDTO.getGoodsId();
        return shopCartService.add(userId, goodsId);
    }

    @RequestMapping(value = "/{goodsId}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@NeedUser DeviceUserVo user, @PathVariable("goodsId") String goodsId) {
        return shopCartService.delete(user.getUid(), goodsId);
    }

    @RequestMapping(value = "/buymsg", method = RequestMethod.POST)
    public APIResult<Boolean> push(@NeedUser DeviceUserVo user) {
        String userId = user.getUid();
        return shopCartService.push(userId);
    }

}
