package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.service.product.ProductService;
import cn.rankin.apiweb.service.shopcart.ShopCartService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.app.vo.DeviceUserVo;
import cn.rankin.data.api.app.vo.ItemGoodsVo;
import cn.rankin.data.api.product.vo.SupportItemVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping(value = "/support")
public class SupportController {

    @Autowired
    private ProductService productService;

    @Autowired
    private ShopCartService shopCartService;

    @RequestMapping(value = "/{supportId}", method = RequestMethod.GET)
    public APIResult<SupportItemVo> getSupport(@NeedUser DeviceUserVo user, @PathVariable("supportId") String supportId) {
        String userId = user.getUid();
        String merchantId = user.getMerchantId();
        APIResult<SupportItemVo> result = productService.getSupport(supportId, merchantId);
        if (!result.getSuccess()) {
            return result;
        }
        SupportItemVo supportItemVo = result.getData();
        List<ItemGoodsVo> itemGoodsVoList = supportItemVo.getGoods();
        shopCartService.isInCart(userId, itemGoodsVoList);
        return result;
    }
}
