package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.service.product.ProductService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.app.vo.DeviceUserVo;
import cn.rankin.data.api.product.vo.TrainingItemVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value = "/training")
public class TrainingController {
    @Autowired
    private ProductService productService;

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<TrainingItemVo> get(@NeedUser DeviceUserVo user, @PathVariable("id") String id) {
        String userId = user.getUid();
        String merchantId = user.getMerchantId();
        APIResult<TrainingItemVo> result = productService.getTraining(id, merchantId);
        if (!result.getSuccess()) {
            return result;
        }
        return result;
    }
}
