package cn.rankin.apiweb.entity;

import java.io.Serializable;

public class AuthResult implements Serializable {

    private String parentId;

    private String itemId;

    private String userId;

    private Integer type;

    private Long startTime;

    private Long endTime;

    public AuthResult() {

    }

    public AuthResult(String parentId, String itemId, String userId, Integer type, Long startTime, Long endTime) {
        this.parentId = parentId;
        this.itemId = itemId;
        this.userId = userId;
        this.type = type;
        this.startTime = startTime;
        this.endTime = endTime;
    }

    public AuthResult(String itemId, String userId, Integer type, Long startTime, Long endTime) {
        this(null, itemId, userId, type, startTime, endTime);
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Long getStartTime() {
        return startTime;
    }

    public void setStartTime(Long startTime) {
        this.startTime = startTime;
    }

    public Long getEndTime() {
        return endTime;
    }

    public void setEndTime(Long endTime) {
        this.endTime = endTime;
    }

    public Long getValidTime() {
        if (startTime == null || endTime == null) {
            return null;
        }
        return endTime - startTime;
    }

    public Boolean isValid() {
        if (endTime == null && startTime != null) {
            return Boolean.TRUE;
        }
        return getValidTime() > 0;
    }
}
