package cn.rankin.apiweb.service.shopcart;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.ShopCartDTO;
import cn.rankin.data.api.user.entity.ShopCart;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(value = "${service.user.name}")
public interface ShopCartClient {

    @RequestMapping(value = "/shopcart", method = RequestMethod.GET)
    APIResult<Page<ShopCart>> getPage(@RequestParam("userId") String userId, @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer pageSize);

    @RequestMapping(value = "/shopcart", method = RequestMethod.PUT)
    APIResult<Boolean> add(@RequestBody ShopCartDTO shopCartDTO);

    @RequestMapping(value = "/shopcart", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@RequestParam("userId") String userId, @RequestParam("goodsId") String goodsId);

    @RequestMapping(value = "/shopcart/totalNum", method = RequestMethod.GET)
    APIResult<Map<String, Long>> getToatlNum(@RequestParam("userId") String userId);

    @RequestMapping(value = "/shopcart/list", method = RequestMethod.POST)
    APIResult<List<ShopCart>> findByIds(@RequestBody List<String> goodsIdList, @RequestParam("userId") String userId);

    @RequestMapping(value = "/shopcart/buymsg", method = RequestMethod.POST)
    APIResult<Boolean> push(@RequestParam("userId") String userId);
}
