package cn.rankin.apiweb.utils;

import cn.rankin.apiweb.entity.GlobalHeader;
import cn.rankin.common.utils.util.SecurityUtil;
import cn.rankin.common.utils.util.UUIDUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.StringUtils;

public class SecurityManager {

    private static final Logger log = LoggerFactory.getLogger(SecurityManager.class);

    // 校验密码是否正确
    public static boolean validate(String password, String key) {
        if (StringUtils.isEmpty(password)) {
            log.error("password is empty");
            return false;
        }

//        String pwdMd5 = SecurityUtil.MD5(password);
//        if (pwdMd5.equals(key)) {
//            return true;
//        }
        if (password.equals(key)) {
            return true;
        }

        return false;
    }

    // 生成token
    public static String generateToken(String str) {
        String uuid = UUIDUtil.getUUID();
        return SecurityUtil.MD5(uuid + str);
    }

    public static Boolean validate(GlobalHeader globalHeader, String path, String token) {
        String sign = globalHeader.getSign();

        StringBuilder sb = new StringBuilder();
        sb.append("path=" + path + "&");
        sb.append("uid=" + globalHeader.getUid() + "&");
        sb.append("eid=" + globalHeader.getEid() + "&");
        String computeSign = SecurityUtil.MD5(sb.toString(), token);

        return computeSign.equals(sign);
    }
}
