package cn.rankin.cmsweb.configuration;


import cn.rankin.cmsweb.assist.resolver.NeedUserResolver;
import cn.rankin.common.utils.web.intercepter.HeaderProcessIntercepter;
import cn.rankin.common.utils.web.intercepter.IgnoreOptionsInterceptor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.EnvironmentAware;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

import java.util.List;

/**
 * 类名：WebConfiguration  <br />
 *
 * 功能：Web相关配置
 *
 * @author tomas <br />
 * 创建时间：2016年7月27日 下午3:57:19  <br />
 * @version 2016年7月27日*/
@EnableWebMvc
@Configuration
public class CmsConfiguration extends WebMvcConfigurerAdapter implements EnvironmentAware {
	// 日志记录器
	private static final Logger logger = LoggerFactory.getLogger(CmsConfiguration.class);

	@Autowired
	private NeedUserResolver needUserResolver;

	// 当前的环境对象
	protected Environment environment;

	public void addInterceptors(InterceptorRegistry registry) {
		registry.addInterceptor(new HeaderProcessIntercepter());
     	registry.addInterceptor(new IgnoreOptionsInterceptor());
	}
	public void addArgumentResolvers(List<HandlerMethodArgumentResolver> argumentResolvers) {
		// 请求体参数解析器
//		argumentResolvers.add(new RequestBodyMappingArgumentResolver());
		argumentResolvers.add(needUserResolver);
		super.addArgumentResolvers(argumentResolvers);
	}
	/**
	 * Set the {@code Environment} that this object runs in.
	 *
	 * @param environment
	 */
	@Override
	public void setEnvironment(Environment environment) {
		this.environment = environment;
	}

}