package cn.rankin.cmsweb.configuration;

import feign.RequestInterceptor;
import feign.RequestTemplate;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Slf4j
@Configuration
public class FeignConfiguration {

    public static class ContentTypeInterceptor implements RequestInterceptor {
        @Override
        public void apply(RequestTemplate template) {
            template.header("Content-Type", "application/json");
        }
    }

    @Bean
    public ContentTypeInterceptor contentTypeInterceptor() {
        return new ContentTypeInterceptor();
    }
}
