package cn.rankin.cmsweb.controller.buymsg;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.code.CmsWebAPICode;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.buymsg.BuyMsgService;
import cn.rankin.cmsweb.service.user.TerminalUserService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.model.BaseCode;
import cn.rankin.data.api.product.vo.MerchantProductVo;
import cn.rankin.data.api.user.vo.TerminalUserVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping(value = "/buymsg")
public class BuyMsgController {

    @Autowired
    private BuyMsgService buyMsgService;

    @Autowired
    private TerminalUserService terminalUserService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<List<MerchantProductVo>> getList(@NeedUser UserDetails user, @RequestParam("userId") String userId) {
        APIResult<TerminalUserVo> userResult = terminalUserService.getUser(userId);
        if (!userResult.getSuccess()) {
            return APIResult.error(new BaseCode(userResult.getCode(), userResult.getMessage()));
        }
        TerminalUserVo terminalUserVo = userResult.getData();
        String merchantId = terminalUserVo.getMerchantId();
        if (user.isPlatForm() || user.getMerchantId().equals(merchantId)) {
            return buyMsgService.getListByBuyMsg(userId, merchantId);
        }else {
            return APIResult.error(CmsWebAPICode.ACCESS_DENIED);
        }
    }
}
