package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.product.GoodsService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.dto.GoodsDTO;
import cn.rankin.data.api.product.vo.GoodsVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/goods")
public class GoodsController {

    @Autowired
    private GoodsService goodsService;

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<GoodsVo> create(@NeedUser UserDetails user, @RequestBody GoodsDTO goodsDTO) {
        return goodsService.create(goodsDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<GoodsVo> update(@RequestBody GoodsDTO goodsDTO) {
        return goodsService.update(goodsDTO);
    }

    @RequestMapping(value = "/{goodsId}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("goodsId") String goodsId) {
        return goodsService.delete(goodsId);
    }
}
