package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.LessonService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.LessonDTO;
import cn.rankin.common.utils.dto.search.SearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.data.api.product.entity.Lesson;
import cn.rankin.data.api.product.vo.LessonVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

@RestController
@RequestMapping(value = "/lesson")
public class LessonController {

    @Autowired
    private LessonService lessonService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<Lesson>> getLessonList(SearchDTO searchDTO) {
        return lessonService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<Lesson> getLesson(@PathVariable("id") String id) {
        return lessonService.getLesson(id);
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Lesson> create(@Valid @RequestBody LessonDTO lessonDTO) {
        return lessonService.create(lessonDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Lesson> update(@Valid @RequestBody LessonDTO lessonDTO) {
        return lessonService.update(lessonDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult delete(@PathVariable("id") String id) {
        return lessonService.delete(id);
    }
}
