package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.PosterServiceInterface;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.data.api.product.dto.PosterDTO;
import cn.rankin.data.api.product.entity.Poster;
import cn.rankin.data.api.product.vo.RecommendVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping(value = "/poster")
public class PosterController {

    @Autowired
    private PosterServiceInterface posterServiceInterface;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<List<Poster>> getPosterList(PosterDTO posterDTO) {
        return posterServiceInterface.search(BeanUtil.convertToMap(posterDTO));
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<Poster> getPoster(@PathVariable("id") String id) {
        return posterServiceInterface.getPoster(id);
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Poster> create(@Valid @RequestBody PosterDTO posterDTO) {
        return posterServiceInterface.create(posterDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Poster> update(@Valid @RequestBody PosterDTO posterDTO) {
        return posterServiceInterface.update(posterDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult delete(@PathVariable("id") String id) {
        return posterServiceInterface.delete(id);
    }


}
