package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.product.TagTypeServiceInterface;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.search.TagTypeSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;

import cn.rankin.data.api.product.dto.TagTypeDTO;
import cn.rankin.data.api.product.vo.TagTypeVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

@Slf4j
@RestController
@RequestMapping(value = "/tagType")
public class TagTypeController {

    @Autowired
    private TagTypeServiceInterface tagTypeServiceInterface;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<TagTypeVo>> search(@NeedUser UserDetails user, TagTypeSearchDTO searchDTO) {

        return tagTypeServiceInterface.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<TagTypeVo> create(@Valid @RequestBody TagTypeDTO tagTypeDTO) {

        return tagTypeServiceInterface.create(tagTypeDTO);

    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<TagTypeVo> update(@RequestBody TagTypeDTO tagTypeDTO) {
        return tagTypeServiceInterface.update(tagTypeDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {

        return tagTypeServiceInterface.delete(id);
    }


    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<TagTypeVo> getTagType(@PathVariable("id") String id) {
        return tagTypeServiceInterface.getTagType(id);
    }

/*    @RequestMapping(value = "/code/{typeCode}", method = RequestMethod.GET)
    public APIResult<List<TagVo>> getTagTypeByCode(@PathVariable("typeCode") String typeCode) {
        return tagTypeServiceInterface.getTagTypeByCode(typeCode,"8d6c69748d064498a4265aa6e72a49cc");
    }*/


}
