package cn.rankin.cmsweb.controller.trade;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.code.CmsWebAPICode;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.trade.order.PayingService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.constant.Constant;
import cn.rankin.data.api.trade.dto.ChargeDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value = "/money")
public class MoneyController {

    @Autowired
    private PayingService payingService;

    @RequestMapping(value = "/charge", method = RequestMethod.POST)
    public APIResult<Boolean> charge(@NeedUser UserDetails user, @RequestBody ChargeDTO chargeDTO) {
        if (!user.getId().equals(Constant.ROOT_ID)) {
            return APIResult.error(CmsWebAPICode.ACCESS_DENIED);
        }
        return payingService.charge(chargeDTO);
    }
}
