package cn.rankin.cmsweb.controller.user;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.user.CmsUserService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.CmsUserDTO;
import cn.rankin.data.api.user.dto.CmsUserSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.data.api.user.vo.CmsUserVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@Slf4j
@RestController
@RequestMapping(value = "/cms/user")
public class CmsUserController {

    @Autowired
    private CmsUserService cmsUserService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<CmsUserVo>> search(@NeedUser UserDetails user, CmsUserSearchDTO searchDTO) {
        if (!user.isPlatForm()) {
            String merchantId = user.getMerchantId();
            searchDTO.setMerchantId(merchantId);
        }
        return cmsUserService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<CmsUserVo> create(@RequestBody CmsUserDTO userDTO) {
        return cmsUserService.create(userDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<CmsUserVo> update(@RequestBody CmsUserDTO userDTO) {
        return cmsUserService.update(userDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {
        return cmsUserService.delete(id);
    }

}
