package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.dto.GoodsDTO;
import cn.rankin.data.api.product.vo.GoodsVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "${service.product.name}")
public interface GoodsService {

    @RequestMapping(value = "/goods", method = RequestMethod.POST)
    APIResult<GoodsVo> create(@RequestBody GoodsDTO goodsDTO);

    @RequestMapping(value = "/goods", method = RequestMethod.PUT)
    APIResult<GoodsVo> update(@RequestBody GoodsDTO goodsDTO);

    @RequestMapping(value = "/goods/{goodsId}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("goodsId") String goodsId);

    @RequestMapping(value = "/goods/ids", method = RequestMethod.GET)
    APIResult<List<GoodsVo>> findByIds(@RequestParam("id") List<String> ids);
}
