package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.GroupDTO;
import cn.rankin.data.api.product.vo.GroupVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface GroupService {

    @RequestMapping(value = "/group/list", method = RequestMethod.GET)
    APIResult<Page<GroupVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/group", method = RequestMethod.POST)
    APIResult<GroupVo> create(@RequestBody GroupDTO groupDTO);

    @RequestMapping(value = "/group", method = RequestMethod.PUT)
    APIResult<GroupVo> update(@RequestBody GroupDTO groupDTO);

    @RequestMapping(value = "/group/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/group/{id}", method = RequestMethod.GET)
    APIResult<GroupVo> getGroup(@PathVariable("id") String id);
}
