package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.MerchantProductDTO;
import cn.rankin.data.api.product.entity.MerchantProduct;
import cn.rankin.data.api.product.vo.MerchantProductVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface MerchantProductService {

    @RequestMapping(value = "/merchant/product", method = RequestMethod.GET)
    APIResult<Page<MerchantProductVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/merchant/product/detail", method = RequestMethod.GET)
    APIResult<MerchantProductVo> getProduct(@RequestParam("pid") String productId, @RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/merchant/product/status", method = RequestMethod.PUT)
    APIResult<Boolean> change(@RequestBody MerchantProductDTO merchantProductDTO);

    @RequestMapping(value = "/merchant/product/tags", method = RequestMethod.PUT)
    APIResult<MerchantProductVo> mountTags(@RequestBody MerchantProductDTO productDTO);

    @RequestMapping(value = "/merchant/product/list", method = RequestMethod.POST)
    APIResult<List<MerchantProductVo>> getList(@RequestBody List<String> productIdList, @RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/merchant/product/pids", method = RequestMethod.POST)
    List<MerchantProduct> findMerchantProductList(@RequestBody List<String> productIdList, @RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/merchant/product/pid", method = RequestMethod.GET)
    MerchantProduct findMerchantProductByPid(@RequestParam("pid") String pid);

}
