package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.PosterDTO;
import cn.rankin.data.api.product.entity.Poster;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface PosterServiceInterface {

    @RequestMapping(value = "/poster/list", method = RequestMethod.GET)
    APIResult<List<Poster>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/poster/{id}", method = RequestMethod.GET)
    APIResult<Poster> getPoster(@PathVariable("id") String id);

    @RequestMapping(value = "/poster", method = RequestMethod.POST)
    APIResult<Poster> create(@RequestBody PosterDTO posterDTO);

    @RequestMapping(value = "/poster", method = RequestMethod.PUT)
    APIResult<Poster> update(@RequestBody PosterDTO posterDTO);

    @RequestMapping(value = "/poster/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);

    @RequestMapping(value = "/poster/updatePosters/{merchantId}", method = RequestMethod.PUT)
    APIResult<List<Poster>> updatePosters(@RequestParam("merchantId") String merchantId,
                                         @RequestBody List<String> posterIdList);

    @RequestMapping(value = "/poster/getPosters/{merchantId}", method = RequestMethod.GET)
    APIResult<List<Poster>> getPosters(@RequestParam("merchantId") String merchantId);
}
