package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.vo.RecommendVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "${service.product.name}")
public interface RecommendService {

    @RequestMapping(value = "/recommend", method = RequestMethod.GET)
    APIResult<List<RecommendVo>> get(@RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/recommend", method = RequestMethod.PUT)
    APIResult<List<RecommendVo>> put(@RequestParam("merchantId") String merchantId, @RequestBody List<String> itemIdList);
}
