package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.TagDTO;
import cn.rankin.data.api.product.vo.TagVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(value = "${service.product.name}")
public interface TagService {

    @RequestMapping(value = "/tag/list", method = RequestMethod.GET)
    APIResult<Page<TagVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/tag", method = RequestMethod.POST)
    APIResult<TagVo> create(@RequestBody TagDTO tagDTO);

    @RequestMapping(value = "/tag", method = RequestMethod.PUT)
    APIResult<TagVo> update(@RequestBody TagDTO tagDTO);

    @RequestMapping(value = "/tag/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);

    @RequestMapping(value = "/tag/{id}", method = RequestMethod.GET)
    APIResult<TagVo> getTag(@PathVariable("id") String id);

    @RequestMapping(value = "/tag/v2/{id}", method = RequestMethod.GET)
    TagVo getTagInfo(@PathVariable("id") String id);
}
