package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.vo.TagVo;
import cn.rankin.data.api.product.dto.TagTypeDTO;
import cn.rankin.data.api.product.vo.TagTypeVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface TagTypeServiceInterface {

    @RequestMapping(value = "/tagType/list", method = RequestMethod.GET)
    APIResult<Page<TagTypeVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/tagType", method = RequestMethod.POST)
    APIResult<TagTypeVo> create(@RequestBody TagTypeDTO tagTypeDTO);

    @RequestMapping(value = "/tagType", method = RequestMethod.PUT)
    APIResult<TagTypeVo> update(@RequestBody TagTypeDTO tagTypeDTO);

    @RequestMapping(value = "/tagType/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/tagType/{id}", method = RequestMethod.GET)
    APIResult<TagTypeVo> getTagType(@PathVariable("id") String id);

    @RequestMapping(value = "/tagType/code/{typeCode}", method = RequestMethod.GET)
    APIResult<List<TagVo>> getTagTypeByCode(@PathVariable("typeCode") String typeCode, @RequestParam("merchantId") String merchantId);
}
