package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.CourseWareDTO;
import cn.rankin.data.api.product.entity.CourseWare;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(value = "${service.product.name}")
public interface WareService {

    @RequestMapping(value = "/ware/list", method = RequestMethod.GET)
    APIResult<Page<CourseWare>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/ware", method = RequestMethod.POST)
    APIResult<CourseWare> create(@RequestBody CourseWareDTO courseWareDTO);

    @RequestMapping(value = "/ware", method = RequestMethod.PUT)
    APIResult<CourseWare> update(@RequestBody CourseWareDTO courseWareDTO);

    @RequestMapping(value = "/ware/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);

    @RequestMapping(value = "/ware/{id}", method = RequestMethod.GET)
    APIResult<CourseWare> getWare(@PathVariable("id") String id);
}
