package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.CmsUserDTO;
import cn.rankin.data.api.user.vo.CmsUserVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;


@FeignClient(name = "${service.user.name}")
public interface CmsUserService {

    @RequestMapping(value = "cms/user", method = RequestMethod.GET)
    APIResult<CmsUserVo> findCmsUserByName(@RequestParam("name") String userName);

    @RequestMapping(value = "cms/user/list", method = RequestMethod.GET)
    APIResult<Page<CmsUserVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "cms/user", method = RequestMethod.POST)
    APIResult<CmsUserVo> create(@RequestBody CmsUserDTO userDTO);

    @RequestMapping(value = "cms/user", method = RequestMethod.PUT)
    APIResult<CmsUserVo> update(@RequestBody CmsUserDTO userDTO);

    @RequestMapping(value = "cms/user/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

}

