package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.MerchantDTO;
import cn.rankin.data.api.user.vo.MerchantVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(name = "${service.user.name}")
public interface MerchantService {

    @RequestMapping(value = "/merchant/list", method = RequestMethod.GET)
    APIResult<Page<MerchantVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/merchant", method = RequestMethod.POST)
    APIResult<MerchantVo> create(@RequestBody MerchantDTO merchantDTO);

    @RequestMapping(value = "/merchant", method = RequestMethod.PUT)
    APIResult<MerchantVo> update(@RequestBody MerchantDTO merchantDTO);

    @RequestMapping(value = "/merchant/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/merchant/{id}", method = RequestMethod.GET)
    APIResult<MerchantVo> getMerchant(@PathVariable("id") String id);

    @RequestMapping(value = "/merchant/ids", method = RequestMethod.GET)
    APIResult<Map<String, MerchantVo>> findByIds(@RequestParam("id") List<String> ids);

}
