package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.TerminalUserDTO;
import cn.rankin.data.api.user.vo.TerminalUserAuthVo;
import cn.rankin.data.api.user.vo.TerminalUserVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(name = "${service.user.name}")
public interface TerminalUserService {

    @RequestMapping(value = "/user/list", method = RequestMethod.GET)
    APIResult<Page<TerminalUserVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/user", method = RequestMethod.POST)
    APIResult<TerminalUserVo> create(@RequestBody TerminalUserDTO userDTO);

    @RequestMapping(value = "/user", method = RequestMethod.PUT)
    APIResult<TerminalUserVo> update(@RequestBody TerminalUserDTO userDTO);

    @RequestMapping(value = "/user/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/user/{id}", method = RequestMethod.GET)
    APIResult<TerminalUserVo> getUser(@PathVariable("id") String id);

    @RequestMapping(value = "/user", method = RequestMethod.GET)
    APIResult<List<TerminalUserVo>> findByCondition(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/campus/ids", method = RequestMethod.GET)
    APIResult<List<TerminalUserVo>> findByCampusIds(@RequestParam("id") List<String> ids);

    @RequestMapping(value = "/user/ids", method = RequestMethod.GET)
    APIResult<List<TerminalUserVo>> findByIds(@RequestParam("id") List<String> ids);

    @RequestMapping(value = "/user/auth/list", method = RequestMethod.GET)
    Page<TerminalUserAuthVo> findAuthList(@RequestParam Map<String,Object> searchDTO);
}
