package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.UserTagDTO;
import cn.rankin.data.api.user.entity.UserTag;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(value = "${service.user.name}")
public interface UserTagServiceInterface {

    @RequestMapping(value = "/userTag/list", method = RequestMethod.GET)
    Page<UserTag> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/userTag", method = RequestMethod.POST)
    UserTag create(@RequestBody UserTagDTO dto);

    @RequestMapping(value = "/userTag", method = RequestMethod.PUT)
    UserTag update(@RequestBody UserTagDTO dto);

    @RequestMapping(value = "/userTag/{id}", method = RequestMethod.DELETE)
    boolean delete(@PathVariable("id") String id);

    @RequestMapping(value = "/userTag/{id}", method = RequestMethod.GET)
    UserTag getUserTag(@PathVariable("id") String id);

    @RequestMapping(value = "/userTag/code/{code}", method = RequestMethod.GET)
    List<UserTag> findUserTagByCodeUid(@PathVariable("code") String code, @PathVariable("uid") String uid);

    @RequestMapping(value = "/userTag/uid/{uid}", method = RequestMethod.GET)
    List<UserTag> findUserTagByUid(@PathVariable("uid") String uid);
}
