package cn.rankin.common.utils.Proxy;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;


class ProxyWrapper implements InvocationHandler {
    //被代理类的对象
    private Object target;

    //绑定被代理对象
    public Object bind(Object target){
        this.target = target;
        //返回实现了被代理类所实现的所有接口的Object对象，即动态代理，需要强制转型
        return Proxy.newProxyInstance(target.getClass().getClassLoader(),
                target.getClass().getInterfaces(), this);
    }

    //日志记录方法
    private void log(String method){
        return;
    }

    /**
     * <p>Discription:覆盖InvocationHandler接口中的invoke()方法</p>
     * @param proxy 需要代理的对象
     * @param method 真实主体要调用的执行方法
     * @param args 调用方法时传递的参数
     * @return
     * @throws Throwable
     * @author       : lcma
     * @update       : 2016年10月9日下午2:46:29
     */
    @Override
    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
        //使用反射中的invoke()对方法进行动态调用
        Object obj = method.invoke(this.target, args);
        return obj;
    }

}

