package cn.rankin.common.utils.enums;

public enum PlatformTypeEnum {

    APP("app"), TV("TV"), WEIXIN("微信");

    private String desc;

    PlatformTypeEnum(String desc) {
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    public static PlatformTypeEnum getByName(String name) {
        if (name == null) {
            return null;
        }
        for (PlatformTypeEnum favoritesType : values()) {
            if (favoritesType.name().equals(name)) {
                return favoritesType;
            }
        }
        return null;
    }

    public static PlatformTypeEnum getByNameWithDefault(String name) {
        if (name == null) {
            return TV;
        }
        for (PlatformTypeEnum favoritesType : values()) {
            if (favoritesType.name().equals(name)) {
                return favoritesType;
            }
        }
        return TV;
    }

}

