package cn.rankin.common.utils.util;

import com.alibaba.fastjson.JSON;
import lombok.Data;

import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Data
public class ListUtil {

    public static <K, V> Map<K, V> convert(List<V> list, String fieldName4Key, Class<V> c) {
        Map<K, V> map = new HashMap<K, V>();
        if (list != null) {
            try {
                PropertyDescriptor propDesc = new PropertyDescriptor(fieldName4Key, c);
                Method methodGetKey = propDesc.getReadMethod();
                for (int i = 0; i < list.size(); i++) {
                    V value = list.get(i);
                    @SuppressWarnings("unchecked")
                    K key = (K) methodGetKey.invoke(list.get(i));
                    map.put(key, value);
                }
            } catch (Exception e) {
                throw new IllegalArgumentException("field can't match the key!");
            }
        }

        return map;
    }

    public static <T> List<T> subtract(List<T> source, List<T> target) {
        if (source == null) {
            return null;
        }else if (source.size() == 0) {
            return new ArrayList<>();
        }

        if (target == null || target.size() == 0) {
            return source;
        }

        List<T> result = new ArrayList<>();
        source.forEach( s -> {
            if (!target.contains(s) && !result.contains(s)) {
                result.add(s);
            }
        });

        return result;
    }

}
