package cn.rankin.common.utils.validator;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.*;

@Constraint(validatedBy = DomainValidator.class)
@Documented
@Target( { ElementType.ANNOTATION_TYPE, ElementType.METHOD, ElementType.FIELD })
@Retention(RetentionPolicy.RUNTIME)
public @interface Domain {

    String message() default "错误的domain值";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};
}
