package cn.rankin.data.api.auth.vo;


import lombok.Data;
import lombok.ToString;

import java.io.Serializable;

@Data
@ToString
public class AuthResult implements Serializable {

    private String pid;

    private String userId;

    private Integer type = 2;

    private Long startTime;

    private Long endTime;

    private Long getValidTime() {
        if (startTime == null || endTime == null) {
            return 0L;
        }
        return endTime - startTime;
    }

    public Boolean isValid() {
        if (endTime == null && startTime != null) {
            return Boolean.TRUE;
        }
        Long validTime = getValidTime();
        if (validTime == null) {
            return Boolean.FALSE;
        }
        return getValidTime() > 0L;
    }
}
