package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.CourseSubTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "p_course_sub_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"course_id", "sub_id", "type"})},
        indexes = {@Index(columnList = "course_id"), @Index(columnList = "sub_id")})
@DynamicInsert
@DynamicUpdate
public class CourseSubRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "course_id")
    private String courseId;

    @Column(name = "sub_id")
    private String subId;

    @Column
    @Enumerated(EnumType.ORDINAL)
    private CourseSubTypeEnum type;

    @Column
    private Integer sort;

    @Column
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
