package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Table(name = "p_course_support_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"course_id", "support_id"})},
        indexes = {@Index(columnList = "course_id"), @Index(columnList = "support_id")})
@Entity
@DynamicInsert
@DynamicUpdate
public class CourseSupportRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "course_id")
    private String courseId;

    @Column(name = "support_id")
    private String supportId;

    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
