package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.ListAttributeConverter;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@ToString
@Entity
@Table(name = "p_courseware", indexes = {@Index(columnList = "code"), @Index(columnList = "title")})
@DynamicInsert
@DynamicUpdate
public class CourseWare implements Serializable{

    @Id
    private String id;

    @Column(nullable = false, unique = true)
    private String code;

    @Column
    private String title;

    private String category;

    @Column
    private String digest;

    @Column(name = "resource_list")
    @Convert(converter = ListAttributeConverter.class)
    private List<String> resourceList;

    @Column(name = "cp_id")
    private String cpId;

    @Column
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;
}

