package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "p_lesson_ware_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"lesson_id", "ware_id"})},
        indexes = {@Index(columnList = "lesson_id"), @Index(columnList = "ware_id")})
@DynamicInsert
@DynamicUpdate
public class LessonWareRelation implements Serializable{

    @Id
    private String id;

    @Column(name = "lesson_id")
    private String lessonId;

    @Column(name = "ware_id")
    private String wareId;

    @Column
    private Integer sort;

    @Column
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

}
