package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Table(name = "p_product_tag_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"pid", "tag_id"})},
        indexes = {@Index(columnList = "pid"), @Index(columnList = "tag_id")})
@Entity
@DynamicUpdate
@DynamicInsert
public class MerchantProductTagRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "pid")
    private String pid;

    @Column(name = "tag_id")
    private String tagId;

    @Column(name = "merchant_id")
    private String merchantId;

    @Column
    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
