package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/*
| field | type | null | default | desc | extra |
|----|:-----|:-------|:------|:-----|:-----|
| id | varchar(512) | no | | 主键 | pri |
| pkg_id | varchar(512) | no | | 课程包id | |
| pid | varchar(512) | no | | | |
| cpPrice | float | no | | 产品在课程包内的cp价格 | |
| sort | int | no | | 顺序 | |
| status | smallint | no | | 状态 | |
| gmt_created | timestamp | no | now | 创建时间 | | |
 */
@Data
@ToString
@Entity
@Table(name = "p_package_product_relation")
@DynamicInsert
@DynamicUpdate
public class PackageProductRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "pkg_id")
    private String pkgId;

    private String pid;

    @Column(name = "cp_price")
    private BigDecimal cpPrice;

    @Column(name = "merchant_price")
    private BigDecimal merchantPrice;

    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
