package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "p_recommend", uniqueConstraints = {@UniqueConstraint(columnNames = {"merchant_id", "pid"})})
@DynamicInsert
@DynamicUpdate
public class Recommend implements Serializable {
    /**
     * 推荐
     */
    private static final long serialVersionUID = 1L;

    @Id
    private String id;

    @Column(name = "merchant_id")
    private String merchantId;

    @Column(name = "pid")
    private String pid;

    @Column(name="sort")
    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private ProductTypeEnum type;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Transient
    private String name;

    @Transient
    private String code;

    @Transient
    private String title;

    @Transient
    private String subTitle;

    @Transient
    private String breadCrumb;

    @Transient
    private String coverUrl;

}
