package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "p_support_reference", uniqueConstraints = {@UniqueConstraint(columnNames = {"fid", "tid"})},
        indexes = {@Index(columnList = "fid"), @Index(columnList = "tid")})
@DynamicInsert
@DynamicUpdate
public class SupportReference implements Serializable {

    @Id
    private String id;

    @Column
    private String fid;

    @Column
    private String tid;

    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
