package cn.rankin.data.api.trade.entity;

import cn.rankin.common.utils.enums.ProductTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "t_order_goods_relation")
@DynamicInsert
@DynamicUpdate
public class OrderGoods implements Serializable {

    @Id
    private String id;

    @Column(name = "order_id")
    private String orderId;

    private String pid;

    @Column(name = "goods_id")
    private String goodsId;

    private Integer quantity;

    @Enumerated(EnumType.ORDINAL)
    private ProductTypeEnum type;

    @Column(name = "detail_id")
    private String detailId;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
