package cn.rankin.data.api.trade.entity;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 功能描述:序列号表模型
 *
 * @author :Ay 2015/11/23
 */
@Entity
@Table(name="sys_serial_number")
@DynamicInsert
@DynamicUpdate
public class SystemSerialNumber implements Serializable {

    @Id
    private String id;

    /**
     * 模块名称
     */
    @Column(name = "module_name", nullable = false)
    private String moduleName;

    /**
     * 模块编码
     */
    @Column(name = "module_code", nullable = false)
    private String moduleCode;

    /**
     * 流水号配置模板
     */
    @Column(name = "config_template")
    private String configTemplate;

    /**
     * 序列号最大值
     */
    @Column(name = "max_serial", nullable = false)
    private Long maxSerial;

    /**
     * 预生成流水号数量
     */
    @Column(name = "pre_max_num")
    private Integer preMaxNum;

    public Integer getPreMaxNum() {
        return preMaxNum;
    }

    public void setPreMaxNum(Integer preMaxNum) {
        this.preMaxNum = preMaxNum;
    }

    public String getModuleName() {
        return moduleName;
    }

    public void setModuleName(String moduleName) {
        this.moduleName = moduleName;
    }

    public String getModuleCode() {
        return moduleCode;
    }

    public void setModuleCode(String moduleCode) {
        this.moduleCode = moduleCode;
    }

    public String getConfigTemplate() {
        return configTemplate;
    }

    public void setConfigTemplet(String configTemplate) {
        this.configTemplate = configTemplate;
    }

    public Long getMaxSerial() {
        return maxSerial;
    }

    public void setMaxSerial(Long maxSerial) {
        this.maxSerial = maxSerial;
    }

    public SystemSerialNumber(String id){
        this.id = id;
    }

    public  SystemSerialNumber(String id,String moduleCode){
        this.id = id;
        this.moduleCode = moduleCode;
    }

    public SystemSerialNumber(){}
}

