package cn.rankin.data.api.trade.vo;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.OrderSplitStatusEnum;
import cn.rankin.common.utils.enums.OrderStatusEnum;
import cn.rankin.data.api.product.vo.GoodsVo;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
@ToString
public class OrderVo implements Serializable {

    private String id;

    private String uid;

    private String serialNo;

    private String merchantId;

    private String merchantName;

    private BigDecimal originPrice;

    private BigDecimal finalPrice;

    private BigDecimal adjustPrice;

    private OrderStatusEnum orderStatus;

    private BaseStatusEnum status;

    private OrderSplitStatusEnum splitStatus;

    private String userCode;

    private String provinceCode;

    private String cityName;

    private String zoneName;

    private String classroomName;

    private String note;

    private String address;

    private String mobile;

    private String name;

    private Date gmtCreated;

    private Date gmtModified;

    private List<OrderGoodsVo> goods;

    private List<OrderDetailVo> detailList;
}
