package cn.rankin.data.api.user.dto;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.PlatformTypeEnum;
import lombok.Data;
import lombok.ToString;

import javax.persistence.Column;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import java.io.Serializable;

@Data
@ToString
public class EventLogDTO implements Serializable {

    private String id;

    private String userId;

    private String merchantId;

    private Integer eventType;

    private String tarName;

    private String tarId;

    private Integer value;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="platform_type")
    private PlatformTypeEnum platformType;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="status")
    private BaseStatusEnum status;
}
