package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "u_buy_msg", uniqueConstraints = {@UniqueConstraint(columnNames = {"user_id", "pid"})})
@DynamicInsert
@DynamicUpdate
public class BuyMsg implements Serializable {

    @Id
    private String id;

    @Column(name = "user_id", nullable = false)
    private String userId;

    @Column(name = "goods_id", nullable = false)
    private String goodsId;

    @Column(nullable = false)
    private String pid;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="status")
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;
}
