package cn.rankin.data.api.user.entity;


import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.GenderEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import javax.validation.constraints.Pattern;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "u_cms_user")
@DynamicInsert
@DynamicUpdate
public class CmsUser implements Serializable {
    private static final long serialVersionUID = 1L;

    @Id
    @Column(name = "id")
    private String id;

    @Column(updatable = false, nullable = false, unique = true)
    private String name;

    private String nickName;

    private String password;

    @Enumerated(EnumType.ORDINAL)
    private GenderEnum gender;

    private String avatar;

    @Temporal(TemporalType.TIMESTAMP)
    private Date birthday;

    @Pattern(regexp = "^[1][3,4,5,7,8,9][0-9]{9}$")
    private String mobile;

    private String mail;

    private String weChat;

    private String qq;

    @Column(name="merchant_id")
    private String merchantId;

    private Integer domain;

    private Boolean isAdmin;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

//    @Transient
//    private List<String> roleIds;

    @Transient
    private String merchantName;

}
