package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.PlatformTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


@Data
@ToString
@Entity
@Table(name = "u_event_log")
@DynamicInsert
@DynamicUpdate
public class EventLog implements Serializable {
    @Id
    @Column(name="id")
    private String id;

    @Column(name="user_id")
    private String userId;

    @Column(name="merchant_id")
    private String merchantId;

    @Column(name="event_type", nullable = false)
    private Integer eventType;

    @Column(name="tar_name")
    private String tarName;

    @Column(name="tar_id")
    private String tarId;

    @Column(name="value")
    private Integer value;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="platform_type")
    private PlatformTypeEnum platformType;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="status")
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

}



