package cn.rankin.data.api.user.entity;

import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


/**
 * The persistent class for the merchant database table.
 * 
 */
@Data
@ToString
@Entity
@Table(name="u_operation_log")
@DynamicInsert
@DynamicUpdate
public class OperationLog implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name = "id")
	private String id;

	@Column(name="user_id")
	private String userId;

	@Column(name="user_name")
	private String userName;

	@Column(name="merchant_id")
	private String merchantId;

	@Column(name="merchant_name")
	private String merchantName;

	@Column(name="ip")
	private String ip;

	@Column(name="domain")
	private Integer domain;

	@Column(name="request_url")
	private String requestUrl;

	@Column(name="param_json")
	private String paramJson;

	@Column(name="method_name")
	private String methodName;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}