package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;


/**
 * The persistent class for the role database table.
 * 
 */
@Data
@ToString
@Entity
@Table(name="u_role")
@DynamicInsert
@DynamicUpdate
public class Role implements Serializable {
	private static final long serialVersionUID = 1L;

	public static final int ROOT = 1;

	@Id
	private String id;

	private String name;

	private String code;

	private Integer admin;

	@Enumerated(EnumType.ORDINAL)
	private BaseStatusEnum status;

	@ManyToMany(fetch= FetchType.EAGER)
	@JoinTable(name="u_role_resource_relation", joinColumns={@JoinColumn(name="roleId")},inverseJoinColumns={@JoinColumn(name="resourceId")})
	private List<Resource> resources;

    @Column(name="gmt_modified")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;
}