package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.springframework.context.annotation.ComponentScan;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


/**
 * The persistent class for the terminal_device database table.
 * 
 */

@Data
@ToString
@Entity
@Table(name="u_device_bind", uniqueConstraints = {@UniqueConstraint(columnNames = {"user_id", "device_code"})})
@DynamicInsert
@DynamicUpdate
public class TerminalDevice implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	private String id;

	@Column(name = "device_code")
	private String deviceCode;

	@Column(name = "merchant")
	private String merchant;

	@Column(name="user_id")
	private String userId;

	private String brand;

	private String ip;

	@Column(name="model_no")
	private String modelNo;

	private String terminal;

	@Enumerated(EnumType.ORDINAL)
	private BaseStatusEnum status = BaseStatusEnum.NORMAL;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;
}