package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "u_terminal_user")
@DynamicInsert
@DynamicUpdate
public class TerminalUser implements Serializable {

    @Id
    private String id;

    @Column(name = "campus_id", updatable = false, nullable = false)
    private String campusId;

    private String name;

    @Column(unique = true, nullable = false, updatable = false)
    private String code;

    @Column(nullable = false)
    private String password;

    @Column(name = "serial_no", nullable = false, updatable = false)
    private Integer serialNo;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Column(name = "merchant_id", updatable = false, nullable = false)
    private String merchantId;

    @Transient
    private String merchantName;

    @Transient
    private String merchantSimple;

    @Transient
    private String merchantContactName;

    @Transient
    private String merchantContactMobile;

    @Transient
    private String contactName;

    @Transient
    private String mobile;

    @Transient
    private String address;

    @Transient
    private String cityName;

    @Transient
    private String zoneName;

    @Transient
    private String provinceName;

    public String getCampusName() {
        return this.provinceName + this.cityName + this.zoneName;
    }

    @Transient
    private int deviceStatus;

}
