package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


/**
 * The persistent class for the role database table.
 * 
 */
@Data
@ToString
@Entity
@Table(name="u_user_recommend", uniqueConstraints = {@UniqueConstraint(columnNames = {"uid", "pid"})})
@DynamicInsert
@DynamicUpdate
public class UserRecommend implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Column(name = "id")
	private String id;

	@Column(name = "uid")
	private String uid;

	@Column(name = "pid")
	private String pid;

	@Column(name = "sort")
	private int sort;

	@Enumerated(EnumType.ORDINAL)
	private ProductTypeEnum type;

	@Enumerated(EnumType.ORDINAL)
	private BaseStatusEnum status;

	@Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
	@Temporal(TemporalType.TIMESTAMP)
	private Date gmtCreated;

	@Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
	@Temporal(TemporalType.TIMESTAMP)
	private Date gmtModified;

	@Transient
	private String name;

	@Transient
	private String code;

	@Transient
	private String title;

	@Transient
	private String subTitle;

	@Transient
	private String breadCrumb;

	@Transient
	private String coverUrl;


}