package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.data.api.app.vo.ItemVo;
import cn.rankin.data.api.product.entity.MerchantProduct;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;


/**
 * The persistent class for the role database table.
 * 
 */
@Data
@ToString
@Entity
@Table(name="u_user_tag")
@DynamicInsert
@DynamicUpdate
public class UserTag implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	private String id;

	@Column(name = "uid")
	private String uid;

	@Column
	private String name;

	@Column(name = "type_code", nullable = false)
	private String typeCode;

	@Column
	private Integer sort;

	@Column
	@Enumerated(EnumType.ORDINAL)
	private BaseStatusEnum status;

	@Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
	@Temporal(TemporalType.TIMESTAMP)
	private Date gmtCreated;

	@Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
	@Temporal(TemporalType.TIMESTAMP)
	private Date gmtModified;

	@Transient
	private List<MerchantProduct> productList;

	@Transient
	private List<UserTagProductRelation> relationList;

	@Transient
	private List<ItemVo> recs;

}