package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


/**
 * The persistent class for the role database table.
 * 
 */
@Data
@ToString
@Entity
@Table(name="u_user_tag_product_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"pid", "tag_id"})})
@DynamicInsert
@DynamicUpdate
public class UserTagProductRelation implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	private String id;

	@Column(name = "pid")
	private String pid;

	@Column(name = "tag_id")
	private String tagId;

	@Column
	private Integer sort;

	@Enumerated(EnumType.ORDINAL)
	private BaseStatusEnum status;

	@Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
	@Temporal(TemporalType.TIMESTAMP)
	private Date gmtCreated;

}