package cn.rankin.productservice.controller;

import cn.rankin.data.api.product.entity.Product;
import cn.rankin.productservice.repository.GoodsRepository;
import cn.rankin.productservice.service.PackageService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
@RequestMapping(value = "/package")
@Slf4j
public class PackageController {

    @Autowired
    private PackageService packageService;

    @Autowired
    private GoodsRepository goodsRepository;

    /**
     * Get plain package info, with childrens field
     * @param pid
     * @return Package
     */
    @RequestMapping(value = "/{pid}", method = RequestMethod.GET)
    public Product getPackage(@PathVariable("pid") String pid) {

        if(null == pid || pid.isEmpty()){
            return null;
        }

        Product pkg =  packageService.get(pid);

        if (null == pkg){
            log.info("Cannot Find Package By pkgId, pkgId={}", pid);
            return null;
        }

        return pkg;
    }
}

