package cn.rankin.productservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.vo.TrainingItemVo;
import cn.rankin.productservice.code.ProductServiceAPICode;
import cn.rankin.productservice.service.app.ItemService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/training")
@Slf4j
public class TrainingController {

    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<TrainingItemVo> findById(@PathVariable("id") String id, @RequestParam("merchantId") String merchantId) {
        TrainingItemVo targetItemVo = itemService.findTrainingItem(id, merchantId);
        if (targetItemVo == null) {
            return APIResult.error(ProductServiceAPICode.NOT_EXISTS);
        }
        log.debug("TargetItemVo-Found, pid={}, merchantId={}, dateDesc={}", id, merchantId, targetItemVo.getDateDesc());
        log.error("TargetItemVo-Found, pid={}, merchantId={}, dateDesc={}", id, merchantId, targetItemVo.getDateDesc());
        return APIResult.ok(targetItemVo);
    }
}

