package cn.rankin.productservice.controller.app;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.vo.ItemVo;
import cn.rankin.data.api.product.entity.TagGroup;
import cn.rankin.productservice.service.app.ItemService;
import cn.rankin.productservice.service.TagGroupService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/app")
public class AppTagController {

    @Autowired
    private TagGroupService tagGroupService;

    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/tagGroup/code/{code}", method = RequestMethod.GET)
    public APIResult<TagGroup> findTagGroupByCode(@PathVariable("code") String code, @RequestParam("merchantId") String merchantId) {
        return tagGroupService.findTagGroupByCode(code, merchantId);
    }

    @RequestMapping(value = "/tag/item/{tagId}", method = RequestMethod.GET)
    public APIResult<Page<ItemVo>> findItemByTagId(@PathVariable("tagId") String tagId, @RequestParam("merchantId") String merchantId,
                                                   @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer pageSize) {
        return itemService.findPageByTagId(tagId, merchantId, pageNo, pageSize);
    }

}
