package cn.rankin.productservice.controller.app;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.vo.SupportItemVo;
import cn.rankin.productservice.code.ProductServiceAPICode;
import cn.rankin.productservice.service.app.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/app/support")
public class SupportController {

    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/{supportId}", method = RequestMethod.GET)
    public APIResult<SupportItemVo> findById(@PathVariable("supportId") String supportId, @RequestParam("merchantId") String merchantId) {
        SupportItemVo supportItemVo = itemService.findSupportItem(supportId, merchantId);
        if (supportItemVo == null) {
            return APIResult.error(ProductServiceAPICode.NOT_EXISTS);
        }
        return APIResult.ok(supportItemVo);
    }
}
