package cn.rankin.productservice.controller.cms;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.dto.GoodsDTO;
import cn.rankin.data.api.product.entity.Goods;
import cn.rankin.productservice.service.GoodsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/goods")
public class GoodsController {

    @Autowired
    private GoodsService goodsService;

    @RequestMapping(value = "/{goodsId}", method = RequestMethod.GET)
    public APIResult<Goods> getGoods(@PathVariable("goodsId") String goodsId) {
        return goodsService.getGoods(goodsId);
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Goods> create(@RequestBody GoodsDTO goodsDTO) {
        return goodsService.create(goodsDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Goods> update(@RequestBody GoodsDTO goodsDTO) {
        return goodsService.update(goodsDTO);
    }

    @RequestMapping(value = "/{goodsId}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("goodsId") String goodsId) {
        return goodsService.delete(goodsId);
    }

    @RequestMapping(value = "/ids", method = RequestMethod.GET)
    public APIResult<List<Goods>> findByIds(@RequestParam("id") List<String> goodsIdList) {
        return goodsService.findByIds(goodsIdList);
    }

    @RequestMapping(value = "/package/{pkgId}", method = RequestMethod.GET)
    public APIResult<List<Goods>> findPackageGoods(@PathVariable("pkgId") String pkgId, @RequestParam("merchantId") String merchantId) {
        return goodsService.findPackageGoods(pkgId, merchantId);
    }
}
