package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Course;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface CourseRepository extends BasicJpaRepository<Course, String> {

    Long countByCode(String code);

    @Query(value = "select c from Course c where c.id in (?1) and c.status = ?2")
    List<Course> findByIds(List<String> ids, BaseStatusEnum status);


    @Query(value = "select c from Course c where c.id = ?1 ")
    Course findCourseById(String id);

    @Query(value = "select c from Course c where c.id = ?1 and c.status = ?2")
    Course findByIdAndStatus(String id, BaseStatusEnum status);


    @Modifying
    @Query(value = "update Course c set c.status = 1 where c.id = ?1")
    Integer deleteById(String id);
}
