package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.CourseSupportRelation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface CourseSupportRelationRepository extends BasicJpaRepository<CourseSupportRelation, String> {

    @Query(value = "select r from CourseSupportRelation r where r.courseId = :courseId and r.status = :status order by r.sort")
    List<CourseSupportRelation> findByCourseId(@Param("courseId") String courseId, @Param("status") BaseStatusEnum status);

    @Query(value = "select r from CourseSupportRelation r where r.supportId = ?1 and r.status = 0 order by r.sort")
    List<CourseSupportRelation> findBySupportId(String supportId);

    List<CourseSupportRelation> findAllByCourseId(String courseId);

    @Transactional
    @Modifying
    @Query(value = "update CourseSupportRelation r set r.status = :status where r.courseId = :courseId")
    Integer deleteByCourseId(@Param("courseId") String courseId, @Param("status")BaseStatusEnum status);
}
