package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Lesson;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Repository
public interface LessonRepository extends BasicJpaRepository<Lesson, String> {

    Long countByCode(String code);

    @Query(value = "select l from Lesson l where l.id in (:ids) and l.status = :status")
    List<Lesson> findByIds(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);

    @Transactional
    @Modifying
    @Query(value = "update Lesson l set l.status = :status where l.id = :id")
    Integer deleteById(@Param("id") String id, @Param("status")BaseStatusEnum status);
}
