package cn.rankin.productservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Package;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

public interface PackageRepository extends BasicJpaRepository<Package, String> {

    Long countByCode(String code);

    @Modifying
    @Query(value = "update Package p set p.status = 1 where p.id = ?1")
    Integer deleteById(String id);

    @Query(value = "select p from  Package p  where p.id = ?1")
    Package findPackageById(String id);

}
