package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Poster;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface PosterRepository extends BasicJpaRepository<Poster, String> {
//    Long countByCode(String code);

    @Query(value = "select p from Poster p where p.id in (?1) and p.status = ?2")
    List<Poster> findByIds(List<String> ids, BaseStatusEnum status);


    @Query(value = "select p from Poster p where p.id = ?1 ")
    Poster findPosterById(String id);


    @Modifying
    @Query(value = "update Poster p set p.status = 1 where p.id = ?1")
    Integer deleteById(String id);

    @Query(value = "select p from Poster p where p.merchantId = ?1 and p.status = ?2")
    List<Poster> findByStatus(String merchantId, BaseStatusEnum normal);

    @Query(value = "select p from Poster p where p.merchantId = ?1 ")
    List<Poster> findByMerchantId(String merchantId);

    @Query(value = "select p from Poster p where p.merchantId = ?1 and p.pid = ?2")
    Poster findByMerchantIdPid(String merchantId, String pid);
}

