package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Product;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface ProductRepository extends BasicJpaRepository<Product, String> {

    Product findByPid(String pid);

    @Query(value = "select p from Product p where p.pid in (?1)")
    List<Product> findByPids(List<String> pids);

    @Query(value = "select p from Product p where p.pid in (?1) and p.status=?2")
    List<Product> findByPidsAndStatus(List<String> pids, BaseStatusEnum status);

    @Modifying
    @Query(value = "update Product p set p.status = 1 where p.pid = ?1")
    Integer deleteByPid(String pid);
}
