package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Recommend;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface RecommendRepository extends BasicJpaRepository<Recommend, String> {

    @Query(value = "select r from Recommend r where r.merchantId = :merchantId and r.status = :status order by r.sort")
    List<Recommend> findByStatus(@Param("merchantId") String merchantId, @Param("status")BaseStatusEnum status);

    List<Recommend> findByMerchantId(String merchantId);
}
