package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.SupportReference;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import javax.transaction.Transactional;
import java.util.List;

public interface SupportReferenceRepository extends BasicJpaRepository<SupportReference, String> {

    @Query(value = "select r from SupportReference r where r.fid = :fid and r.status = :status order by r.sort")
    List<SupportReference> findByFid(@Param("fid") String fid, @Param("status") BaseStatusEnum status);

    List<SupportReference> findAllByFid(String fid);

    @Transactional
    @Modifying
    @Query(value = "update SupportReference r set r.status = 1 where r.fid = :fid")
    Integer deleteByFid(@Param("fid") String fid);

}
