package cn.rankin.productservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.TagGroup;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;


public interface TagGroupRepository extends BasicJpaRepository<TagGroup, String> {

    Long countByCode(String code);

    @Query(value = "select g from TagGroup g where g.code = ?1 and g.merchantId = ?2")
    TagGroup findFirstByCode(String code, String merchantId);

    @Modifying
    @Query(value = "update TagGroup g set g.status = 1 where g.id = :id")
    Integer deleteById(@Param("id") String id);
}
