package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Tag;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface TagRepository extends BasicJpaRepository<Tag, String> {

    @Query(value = "select t from Tag t where t.groupId = ?1 and t.status = ?2  order by t.sort")
    List<Tag> findByGroupId(String groupId, BaseStatusEnum status);

    /*  add   */
    @Query(value = "select t from Tag t where t.groupId = ?1 order by t.sort")
    List<Tag> findByTagTypeId(String tagTypeId);


    @Query(value = "select t from Tag t where t.typeCode = ?1 and t.merchantId = ?2  and t.status = ?3 order by t.sort")
    List<Tag> findByTypeCode(String typeCode,String merchantId, BaseStatusEnum status);

    @Query(value = "select t from Tag t where t.typeCode = ?1 order by t.sort")
    List<Tag> findByTypeCode(String typeCode);

    @Query(value = "select t from Tag t where t.id in (?1) and t.status = ?2")
    List<Tag> findByIds(List<String> tagIdList, BaseStatusEnum status);

    @Modifying
    @Query(value = "update Tag t set t.status = 1 where t.id = ?1")
    Integer deleteById(String tagId);
}
