package cn.rankin.productservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.TagType;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;


public interface TagTypeRepository extends BasicJpaRepository<TagType, String> {

    Long countByCode(String code);

    @Query(value = "select t from TagType t where t.code = ?1  order by t.sort ")
    TagType findFirstByCode(String code);

    @Modifying
    @Query(value = "update TagType t set t.status = 1 where t.id = :id")
    Integer deleteById(@Param("id") String id);
}
