package cn.rankin.productservice.repository;


import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Training;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface TrainingRepository extends BasicJpaRepository<Training, String> {

    Long countByCode(String code);

    @Query(value = "select s from Training s where s.id in (:ids) and s.status = :status")
    List<Training> findByIds(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);

    @Transactional
    @Modifying
    @Query(value = "update Training s set s.status = 1 where s.id = :id")
    Integer deleteById(@Param("id") String id);

}
