package cn.rankin.productservice.service;

import cn.rankin.common.utils.api.model.APICode;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.product.dto.TrainingDTO;
import cn.rankin.data.api.product.entity.Training;
import cn.rankin.productservice.repository.ProductRepository;
import cn.rankin.productservice.repository.TrainingRepository;
import cn.rankin.productservice.utils.DTOConverter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

@Service
public class TrainingService {
    @Autowired
    private TrainingRepository repo;

    @Autowired
    private ProductRepository productRepository;


    @Transactional
    public APIResult<Training> create(TrainingDTO dto) {
        String code = dto.getCode();
        if (repo.countByCode(code) > 0L) {
            return APIResult.error(APICode.ALREADY_EXISTS);
        }

        Training entity = DTOConverter.convert(dto);
        Training result = repo.save(entity);

        return APIResult.ok(result);
    }

    public Training get(String pid){
        /*
        TODO
         */
        Training entity = repo.find(pid);
        return entity;
    }

    @Transactional
    public APIResult delete(String pid){
        /*
        TODO
         */
        Integer count = repo.deleteById(pid);
        if (count > 0){
            return APIResult.ok(true);
        }

        return APIResult.error(APICode.NOT_EXISTS);
    }

    @Transactional
    public APIResult update(TrainingDTO dto){

        /*
        TODO
         */

        Training entity = DTOConverter.convert(dto);
        Training result = repo.update(entity);

        return APIResult.ok(result);
    }

}
