package cn.rankin.productservice.service.app;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.util.ListUtil;
import cn.rankin.data.api.product.entity.CourseSubRelation;
import cn.rankin.data.api.product.entity.CourseWare;
import cn.rankin.data.api.product.entity.Lesson;
import cn.rankin.data.api.product.entity.LessonWareRelation;
import cn.rankin.productservice.code.ProductServiceAPICode;
import cn.rankin.productservice.repository.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class AppLessonService {

    @Autowired
    private LessonRepository lessonRepository;

    @Autowired
    private WareRepository wareRepository;

    @Autowired
    private LessonWareRelationRepository lessonWareRelationRepository;

    @Autowired
    private CourseSubRelationRepository courseSubRelationRepository;

/*    public APIResult<Lesson> getLesson(String lessonId, String courseId) {
        Lesson lesson = lessonRepository.find(lessonId);
        if (lesson == null || !BaseStatusEnum.NORMAL.equals(lesson.getStatus())) {
            return APIResult.error(ProductServiceAPICode.NOT_EXISTS);
        }

        // set lesson sort from relation
        CourseSubRelation courseSubRelation = courseSubRelationRepository.findFirstByCourseIdOrderBySort(courseId);
        if (courseSubRelation == null) {
            return APIResult.error(ProductServiceAPICode.error("课程关系不存在"));
        }
        lesson.setSort(courseSubRelation.getSort());

        // get courseware id list
        List<LessonWareRelation> lessonWareRelationList = lessonWareRelationRepository.findByLessonId(lessonId, BaseStatusEnum.NORMAL);
        if (CollectionUtils.isEmpty(lessonWareRelationList)) {
            lesson.setWareList(new ArrayList<>());
            return APIResult.ok(lesson);
        }
        List<String> wareIdList = new ArrayList<>();
        lessonWareRelationList.forEach(relation -> wareIdList.add(relation.getWareId()));

        // get courseware list with sort
        List<CourseWare> courseWareList = wareRepository.findByIdIn(wareIdList, BaseStatusEnum.NORMAL);
        Map<String, CourseWare> courseWareMap = ListUtil.convert(courseWareList, "id", CourseWare.class);
        List<CourseWare> sortWareList = new ArrayList<>();
        for (String wareId : wareIdList) {
            CourseWare courseWare = courseWareMap.get(wareId);
            if (courseWare == null) {
                continue;
            }
            sortWareList.add(courseWare);
        }
        lesson.setWareList(sortWareList);

        return APIResult.ok(lesson);
    }*/

    /*   --- rewrite 2018-05-14--------------------------------------  start   */
    public Lesson getLesson(String lessonId, String courseId) {
        Lesson lesson = lessonRepository.find(lessonId);
        if (lesson == null || !BaseStatusEnum.NORMAL.equals(lesson.getStatus())) {
            return null;
        }

        // set lesson sort from relation
        CourseSubRelation courseSubRelation = courseSubRelationRepository.findFirstByCourseIdOrderBySort(courseId);
        if (courseSubRelation == null) {
            return null;
        }
        lesson.setSort(courseSubRelation.getSort());

        // get courseware id list
        List<LessonWareRelation> lessonWareRelationList = lessonWareRelationRepository.findByLessonId(lessonId, BaseStatusEnum.NORMAL);
        if (CollectionUtils.isEmpty(lessonWareRelationList)) {
            lesson.setWareList(new ArrayList<>());
            return lesson;
        }
        List<String> wareIdList = new ArrayList<>();
        lessonWareRelationList.forEach(relation -> wareIdList.add(relation.getWareId()));

        // get courseware list with sort
        List<CourseWare> courseWareList = wareRepository.findByIdIn(wareIdList, BaseStatusEnum.NORMAL);
        Map<String, CourseWare> courseWareMap = ListUtil.convert(courseWareList, "id", CourseWare.class);
        List<CourseWare> sortWareList = new ArrayList<>();
        for (String wareId : wareIdList) {
            CourseWare courseWare = courseWareMap.get(wareId);
            if (courseWare == null) {
                continue;
            }
            sortWareList.add(courseWare);
        }
        lesson.setWareList(sortWareList);

        return lesson;
    }
    /*   --- rewrite 2018-05-14--------------------------------------  end   */
}
