package cn.rankin.productservice.service.auth;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.auth.dto.AuthQueryDTO;
import cn.rankin.data.api.auth.vo.AuthVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "auth-client", url = "${remote.auth.url}")//, fallback = AuthClient.AuthServiceHystrix.class)
public interface AuthClient {

    @RequestMapping(value = "/acenter/v1/auth/list", method = RequestMethod.POST, consumes = "application/json")
    APIResult<List<AuthVo>> auth(@RequestBody AuthQueryDTO authQueryDTO);

    @RequestMapping(value = "/acenter/v1/auth/uid/{uid}", method = RequestMethod.GET, consumes = "application/json")
    APIResult<List<AuthVo>> getUserValidProduct(@PathVariable("uid") String uid, @RequestParam("bizCode") String bizCode);

//    @Component
//    class AuthServiceHystrix implements AuthClient {
//
//        @Override
//        public APIResult<List<AuthVo>> auth(AuthQueryDTO authQueryDTO) {
//            return APIResult.error(ProductServiceAPICode.SERVER_ERROR);
//        }
//    }
}
