package cn.rankin.productservice.utils;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.CourseSubTypeEnum;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import cn.rankin.data.api.product.dto.*;
import cn.rankin.data.api.product.entity.*;
import cn.rankin.data.api.product.entity.Package;
import cn.rankin.data.api.product.vo.CourseSubItemVo;
import org.springframework.beans.BeanUtils;

public class DTOConverter {

    // PosterDTO to Poster
    public static Poster convert(PosterDTO posterDTO) {
        Poster poster = new Poster();
        BeanUtils.copyProperties(posterDTO, poster);
//        course.setType(ProductTypeEnum.COURSE);

        return poster;
    }

    // CourseDTO to Course
    public static Course convert(CourseDTO courseDTO) {
        Course course = new Course();
        BeanUtils.copyProperties(courseDTO, course);
        course.setType(ProductTypeEnum.COURSE);

        return course;
    }

    // WareDTO to Ware
    public static CourseWare convert(CourseWareDTO courseWareDTO) {
        CourseWare CourseWare = new CourseWare();
        BeanUtils.copyProperties(courseWareDTO, CourseWare);
        return CourseWare;
    }

    // SupportDTO to Support
    public static Support convert(SupportDTO supportDTO) {
        Support support = new Support();
        BeanUtils.copyProperties(supportDTO, support);
        support.setType(ProductTypeEnum.SUPPORT);
        return support;
    }

    // LessonDTO to Lesson
    public static Lesson convert(LessonDTO lessonDTO) {
        Lesson lesson = new Lesson();
        BeanUtils.copyProperties(lessonDTO, lesson);

        return lesson;
    }

    // Lesson to CourseSubItemVo
    public static CourseSubItemVo convert(Lesson lesson) {
        CourseSubItemVo subItemVo = new CourseSubItemVo();
        BeanUtils.copyProperties(lesson, subItemVo);
        subItemVo.setType(CourseSubTypeEnum.LESSON);
        return subItemVo;
    }

    // CourseSubRelationDTO convert CourseSubRelation
    public static CourseSubRelation convert(String courseId, CourseSubRelationDTO courseSubRelationDTO) {
        CourseSubRelation relation = new CourseSubRelation();
        relation.setCourseId(courseId);
        relation.setSubId(courseSubRelationDTO.getId());
        relation.setType(courseSubRelationDTO.getType());

        return relation;
    }

    public static PackageProductRelation convert(String pkgId, PackageProductDTO productDTO) {
        PackageProductRelation relation = new PackageProductRelation();
        relation.setPkgId(pkgId);
        relation.setPid(productDTO.getPid());
        relation.setCpPrice(productDTO.getCpPrice());
        relation.setMerchantPrice(productDTO.getMerchantPrice());
        relation.setStatus(BaseStatusEnum.NORMAL);
        return relation;
    }
    /*add*/
    public static TagType convert(TagTypeDTO tagTypeDTO) {
        TagType tagType = new TagType();
        tagType.setId(tagTypeDTO.getId());
        tagType.setCode(tagTypeDTO.getCode());
        tagType.setName(tagTypeDTO.getName());
        tagType.setSort(tagTypeDTO.getSort());
        tagType.setStatus(tagTypeDTO.getStatus());
        return tagType;
    }

    public static TagGroup convert(GroupDTO groupDTO) {
        TagGroup tagGroup = new TagGroup();
        tagGroup.setId(groupDTO.getId());
        tagGroup.setCode(groupDTO.getCode());
        tagGroup.setName(groupDTO.getName());
        tagGroup.setMerchantId(groupDTO.getMerchantId());
        tagGroup.setSort(groupDTO.getSort());
        tagGroup.setStatus(groupDTO.getStatus());
        return tagGroup;
    }

    public static Tag convert(TagDTO tagDTO) {
        Tag tag = new Tag();
        BeanUtils.copyProperties(tagDTO, tag);
        return tag;
    }

    public static Product convert(Course course) {
        Product product = new Product();
        product.setId(course.getId());
        product.setPid(course.getId());
        product.setCpId(course.getCpId());
        product.setCode(course.getCode());
        product.setName(course.getName());
        product.setType(ProductTypeEnum.COURSE);
        product.setStatus(course.getStatus());
        return product;
    }

    public static Product convert(Support support) {
        Product product = new Product();
        product.setId(support.getId());
        product.setPid(support.getId());
        product.setCode(support.getCode());
        product.setName(support.getName());
        product.setType(ProductTypeEnum.SUPPORT);
        product.setCpId(support.getCpId());
        product.setStatus(support.getStatus());
        return product;
    }

    public static Product convert(Package pkg) {
        Product product = new Product();
        product.setId(pkg.getId());
        product.setPid(pkg.getId());
        product.setCode(pkg.getCode());
        product.setName(pkg.getName());
        product.setType(ProductTypeEnum.PACKAGE);
        product.setStatus(pkg.getStatus());
        return product;
    }

    public static Product convert(Training obj) {
        Product product = new Product();
        product.setId(obj.getId());
        product.setPid(obj.getId());
        product.setCode(obj.getCode());
        product.setName(obj.getTitle());
        product.setType(ProductTypeEnum.TRAINING);
        product.setStatus(obj.getStatus());
        return product;
    }

    public static Goods convert(GoodsDTO goodsDTO) {
        Goods goods = new Goods();
        BeanUtils.copyProperties(goodsDTO, goods);
        return goods;
    }

    public static Package convert(PackageDTO packageDTO) {
        Package pkg = new Package();
        pkg.setId(packageDTO.getId());
        pkg.setCode(packageDTO.getCode());
        pkg.setName(packageDTO.getName());
        pkg.setStatus(packageDTO.getStatus());
        return pkg;
    }

    public static Training convert(TrainingDTO dto) {
        Training obj = new Training();
        BeanUtils.copyProperties(dto, obj);
        return obj;
    }

}
