package cn.rankin.productservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.enums.BaseOrderEnum;
import cn.rankin.productservice.ProductServiceApplication;
import cn.rankin.data.api.product.entity.MerchantProduct;
import cn.rankin.productservice.service.MerchantProductService;
import com.alibaba.fastjson.JSON;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.LinkedHashMap;

@Slf4j
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = ProductServiceApplication.class)
public class MerchantProductServiceTest {

    @Autowired
    private MerchantProductService productService;

    @Test
    public void search() throws Exception {
        MerchantProduct merchantProduct = new MerchantProduct();

        LinkedHashMap<String, BaseOrderEnum> sort = new LinkedHashMap<>();
        sort.put("gmtModified", BaseOrderEnum.DESC);
        APIResult<Page<MerchantProduct>> result = productService.search(merchantProduct, 0, 10, sort);
        log.info(JSON.toJSONString(result));
    }

}