package cn.rankin.resourceservice.dto;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.data.api.resource.entity.Resource;
import cn.rankin.common.utils.constant.ResourceType;
import cn.rankin.resourceservice.controller.ResourceController;
import lombok.Data;
import lombok.ToString;
import org.apache.commons.lang.StringUtils;

import java.io.Serializable;
import java.util.Date;

@Data
@ToString
public class ResourceDetail implements Serializable {

    private String rid;

    private String no;

    private String title;

    private Integer type;

    private String id;

    private String bucket;

    private String format;

    private Long size;

    private Date createTime;

    private Date updateTime;

    private BaseStatusEnum status;

    private String fullPath;

    // 清晰度, {fluent, standard, high, superclear}
    private String quality;

    // 类型
    private Integer dataRate;

    public Resource toNativeResource() {
        if (type.intValue() == ResourceType.AUDIO) {
            return toNativeAudio();
        } else if (type.intValue() == ResourceType.VIDEO) {
            return toNativeVideo();
        }
        return null;
    }

    public Resource toNativeVideo() {
        Resource resource = new Resource();
        resource.setId(id);
        resource.setCode(no);
        resource.setName(title);
        resource.setType(type);
        if(StringUtils.isNotBlank(fullPath)){
            resource.setUrl(fullPath.replace(ResourceController.HTTP_VIDEO_DOMAIN, ResourceController.HTTPS_VIDEO_DOMAIN)
                                    .replace(ResourceController.LJ_VIDEO_DOMAIN, ResourceController.HTTPS_VIDEO_DOMAIN));
        }else{
            resource.setUrl(fullPath);
        }
        resource.setFormat(format);
        resource.setQuality(quality);
        resource.setSize(size);
        resource.setStatus(status);
        resource.setGmtCreated(createTime);
        resource.setGmtModified(updateTime);
        return resource;
    }

    public Resource toNativeAudio() {
        Resource resource = new Resource();
        resource.setId(id);
        resource.setCode(no);
        resource.setName(title);
        resource.setType(type);
        resource.setUrl(fullPath);
        resource.setFormat(format);
        resource.setSize(size);
        resource.setStatus(status);
        resource.setGmtCreated(createTime);
        resource.setGmtModified(updateTime);
        return resource;
    }
}
