package cn.rankin.resourceservice.dto;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


@Data
@ToString
public class ResourceVideo implements Serializable {

    private static final long serialVersionUID = 1L;

    // 主键 uuid
    private String id;

    // 关联资源id
    private String rid;

    // oss bucket名
    private String bucket;

    // oss路径
    private String path;

    // 格式，目前可取两个值{mp4, m3u8}
    private String format;

    // 清晰度, {fluent, standard, high, superclear}
    private String quality;

    // 类型
    private Integer dataRate;
    // 类型
    private Long size;

    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

    @Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;

    //表示状态,取值{0,1}, 分别表示{'正常状态','已删除'}
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status = BaseStatusEnum.NORMAL;

    @Transient
    private String fullPath;

}
