package cn.rankin.resourceservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.resourceservice.dto.ResourceDetail;
import cn.rankin.resourceservice.dto.ResourceRemote;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(value = "remote-resource", url = "${remote.resource.url}")
public interface RemoteResourceProxy {

    @RequestMapping(value = "rcenter/v1/resources/page", method = RequestMethod.GET)
    APIResult<Page<ResourceRemote>> findPage(@RequestParam Map<String, Object> map);

    @RequestMapping(value = "rcenter/v1/resources/no/{code}", method = RequestMethod.GET)
    APIResult<ResourceRemote> findByCode(@PathVariable("code") String code);

    @RequestMapping(value = "rcenter/v1/resources/{id}", method = RequestMethod.GET)
    APIResult<ResourceRemote> findById(@PathVariable("id") String id);

//    @RequestMapping(value = "rcenter/v1/resources", method = RequestMethod.GET)
//    APIResult<List<ResourceRemote>> getBatch(@RequestParam("ids") List<String> ids);

    @RequestMapping(value = "rcenter/v1/resources/files", method = RequestMethod.GET)
    APIResult<List<ResourceDetail>> getBatch(@RequestParam("ids") List<String> ids);

    @RequestMapping(value = "/rcenter/v1/resources/mgt", method = RequestMethod.POST)
    APIResult<ResourceDetail> saveResources(@RequestBody ResourceRemote resourceRemote);

    @RequestMapping(value = "/rcenter/v1/resources/mgt", method = RequestMethod.PUT)
    APIResult updateResources(@RequestBody ResourceRemote resourceRemote);

}
