package cn.rankin.task.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.trade.entity.OrderDetail;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface OrderDetailRepository extends BasicJpaRepository<OrderDetail, String> {

    @Query(value = "select * from t_order_detail o where (o.order_status = 5 and o.status = 0 and o.type = 0) or (o.order_status = 7 and o.status = 0 and o.type = 1) order by o.order_id limit ?1", nativeQuery = true)
    List<OrderDetail> findForCompleteList(Integer limit);

    @Query(value = "select o from OrderDetail o where o.orderId in (?1) and o.status = 0")
    List<OrderDetail> findByOrderIds(List<String> orderIdList);

    @Modifying
    @Query(value = "update t_order_detail o set o.order_status = 4 where (o.id = ?1 and o.status = 0 and o.order_status = 7 and o.type = 1) or (o.order_status = 5 and o.type = 0 and o.id = ?1 and o.status = 0)", nativeQuery = true)
    Integer complete(String detailId);
}
