package cn.rankin.task.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.trade.entity.OrderGoods;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface OrderGoodsRepository extends BasicJpaRepository<OrderGoods, String> {

    @Query(value = "select g from OrderGoods g where g.orderId in (?1)")
    List<OrderGoods> findByOrderIds(List<String> orderIds);

    @Query(value = "select g from OrderGoods g where g.detailId in (?1)")
    List<OrderGoods> findByDetailIds(List<String> detailIds);

    @Modifying
    @Query(value = "update OrderGoods r set r.detailId = :detailId where r.orderId = :orderId and r.goodsId in (:ids)")
    Integer updateDetailIdByIds(@Param("detailId") String detailId, @Param("orderId") String orderId, @Param("ids") List<String> ids);
}
