package cn.rankin.task.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.trade.entity.Order;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface OrderRepository extends BasicJpaRepository<Order, String> {

    @Query(value = "select * from t_order o where o.order_status = 1 and o.split_status = 0 and o.status = 0 limit ?1", nativeQuery = true)
    List<Order> findSplitOrders(Integer limit);

    @Query(value = "select * from t_order o where o.order_status != 4 and o.status = 0 and o.split_status != 0 limit ?1", nativeQuery = true)
    List<Order> findCompleteOrders(Integer limit);

    // 已拆分
    @Modifying
    @Query(value = "update Order o set o.splitStatus = 2, o.orderStatus = 5 where o.splitStatus = 0 and o.orderStatus = 1 and o.status = 0 and o.id = ?1")
    Integer split(String orderId);

    // 不需要拆分，但也要处理
    @Modifying
    @Query(value = "update Order o set o.splitStatus = 1, o.orderStatus = 5 where o.splitStatus = 0 and o.orderStatus = 1 and o.status = 0 and o.id = ?1")
    Integer process(String orderId);

    // 标记订单完成
    @Modifying
    @Query(value = "update Order o set o.orderStatus = 4 where o.orderStatus not in (0,2,3,4) and o.status = 0 and o.id in (?1)")
    Integer complete(List<String> orderIdList);
}
