package cn.rankin.task.service;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.task.code.TaskAPICode;
import cn.rankin.data.api.auth.dto.AuthDTO;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import java.util.List;

@FeignClient(name = "auth-service", url = "${remote.auth.url}", fallback = AuthService.AuthServiceHystrix.class)
public interface AuthService {

    @RequestMapping(value = "/acenter/v1/auth/list", method = RequestMethod.POST)
    APIResult add(@RequestBody List<AuthDTO> authList);

    @RequestMapping(value = "/acenter/v1/auth", method = RequestMethod.POST)
    APIResult add(@RequestBody AuthDTO authDTO);

    @Component
    class AuthServiceHystrix implements AuthService {

        @Override
        public APIResult add(List<AuthDTO> authList) {
            return APIResult.error(TaskAPICode.SERVER_ERROR);
        }

        @Override
        public APIResult add (AuthDTO authDTO) {
            return APIResult.error(TaskAPICode.SERVER_ERROR);
        }
    }
}
