package cn.rankin.tradeservice.configuration;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.EnvironmentAware;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;


/**
 * 类名：PersistConfiguration  <br />
 *
 * 功能：持久化相关配置
 *
 * @author xtwin <br />
 * 创建时间：2016年7月26日 上午9:56:48  <br />
 * @version 2016年7月26日
 */
@Configuration
@EntityScan(basePackages={"cn.rankin.data.api.trade"})
public class PersistConfiguration implements EnvironmentAware {
	
	// 日志记录器
	private static final Logger logger = LoggerFactory.getLogger(PersistConfiguration.class);
	
	// 应用环境信息
	private Environment environment;

	/**
	 * 功能: 由spring注入环境信息 <br/>
	 * 
	 * 重写：xtwin <br/>
	 * 
	 * @version ：2016年7月27日 上午10:02:15<br/>
	 * 
	 * @param environment <br/>
	 * @see EnvironmentAware#setEnvironment(Environment)
	 */
	@Override
	public void setEnvironment(Environment environment) {
		this.environment = environment;
	}
}
