package cn.rankin.tradeservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.trade.entity.OrderDetail;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface OrderDetailRepository extends BasicJpaRepository<OrderDetail, String> {

    @Modifying
    @Query(value = "update OrderDetail o set o.orderStatus = 6, o.trackNo = ?2 where o.orderStatus = 5 and o.status = 0 and o.id = ?1")
    Integer send(String detailId, String trackNo);

    @Modifying
    @Query(value = "update OrderDetail o set o.orderStatus = 7 where o.orderStatus = 6 and o.status = 0 and o.id = ?1")
    Integer receive(String detailId);

    @Query(value = "select o from OrderDetail o where o.orderId in (?1)")
    List<OrderDetail> findByOrderIds(List<String> orderIds);
}
