package cn.rankin.tradeservice.service;

import cn.rankin.data.api.trade.dto.OrderGoodsDTO;
import cn.rankin.data.api.trade.entity.OrderGoods;
import cn.rankin.tradeservice.repository.OrderGoodsRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

import static cn.rankin.tradeservice.utils.DTOConverter.convert;

@Service
public class OrderGoodsService {

    @Autowired
    private OrderGoodsRepository orderGoodsRepository;

    @Transactional
    public void createRelation(String orderId, List<OrderGoodsDTO> orderGoodsDTOList) {
        List<OrderGoods> orderGoodsList = new ArrayList<>();
        for (OrderGoodsDTO orderGoodsDTO : orderGoodsDTOList) {
            OrderGoods relation = convert(orderId, orderGoodsDTO);
            orderGoodsList.add(relation);
        }
        orderGoodsRepository.save(orderGoodsList);
    }

    public List<OrderGoods> findByOrderId(String orderId) {
        return orderGoodsRepository.findByOrderId(orderId);
    }
}
