package cn.rankin.tradeservice.service;

import cn.rankin.tradeservice.configuration.Constant;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;

@Service
@Slf4j
public class SerialNumberService {

    @Transactional
    public String getMasterOrderSN() {
        String name = Constant.ORDER_MODULE;
        String code = Constant.MASTER_ORDER_CODE;
        return getSerialNumber(name, code);
    }

    public String getSlaveOrderSN() {
        String name = Constant.ORDER_MODULE;
        String code = Constant.SLAVE_ORDER_CODE;
        return getSerialNumber(name, code);
    }

    public String getSerialNumber(String name, String code) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMdd");

        Date date = new Date();
        String dateStr = simpleDateFormat.format(date);

        Random random = new Random();
        int randNum = (int) (random.nextDouble() * (99999 - 10000 + 1)) + 10000;// 获取5位随机数

        return String.format("%s%05d%s", dateStr, randNum, code);// 当前时间
    }
}
