package cn.rankin.userservice.configuration;

import cn.rankin.common.utils.util.UUIDUtil;
import cn.rankin.common.utils.constant.Constant;
import feign.Logger;
import feign.RequestInterceptor;
import feign.RequestTemplate;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Slf4j
@Configuration
public class FeignConfiguration {

    public static class FeignHeaderInterceptor implements RequestInterceptor {
        // 设置公共头参数
        @Override
        public void apply(RequestTemplate requestTemplate) {
            requestTemplate.header("bizCode", "0129");
            requestTemplate.header("requestId", UUIDUtil.getUUID());
            requestTemplate.header("appCode", Constant.APP_CODE);
            requestTemplate.header("platform", "3");
            requestTemplate.header("os", "0");
            requestTemplate.header("dist", "1112");
            requestTemplate.header("terminal", "mobile");
            log.info("run header interceptor");
        }
    }

    @Bean
    public FeignHeaderInterceptor feignHeaderInterceptor() {
        return new FeignHeaderInterceptor();
    }

    @Bean
    public Logger.Level feignLoggerLevel() {

        return Logger.Level.HEADERS;

    }
}
