package cn.rankin.userservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.user.dto.EventLogDTO;
import cn.rankin.data.api.user.entity.EventLog;
import cn.rankin.userservice.service.EventLogService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping(value = "/event")
public class EventLogController {

    @Autowired
    private EventLogService eventLogService;

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Boolean> addLog(@RequestBody EventLogDTO eventLogDTO) {
        return eventLogService.addLog(eventLogDTO);
    }

    @RequestMapping(value = "/{uid}", method = RequestMethod.GET)
    public List<String> getCoursesFromLogs(@PathVariable("uid") String uid){
        List<EventLog> eventLogs = eventLogService.findEventLogs(uid);
        List<String> courseIds = new ArrayList<>();
        eventLogs.forEach(eventLog ->{
            String tarId = eventLog.getTarId();
            if(StringUtils.isNotEmpty(tarId)){
                String courseId = tarId.split("_")[0];
                if(!courseIds.contains(courseId))
                    courseIds.add(courseId);
            }
        });

        List<String> result = new ArrayList<>(courseIds);
        return result;
    }

}
