package cn.rankin.userservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.trade.dto.ChargeDTO;
import cn.rankin.data.api.user.dto.PayDTO;
import cn.rankin.userservice.service.PayingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/money")
public class PayController {

    @Autowired
    private PayingService payingService;

    @RequestMapping(value = "/pay", method = RequestMethod.POST)
    public APIResult<Boolean> pay(@RequestBody PayDTO payDTO) {
        return payingService.pay(payDTO.getMerchantId(), payDTO.getQuantity(), payDTO.getType(), payDTO.getReceiptId(), payDTO.getNote());
    }

    @RequestMapping(value = "/charge", method = RequestMethod.POST)
    public APIResult<Boolean> charge(@RequestBody ChargeDTO chargeDTO) {
        return payingService.charge(chargeDTO.getMerchantId(), chargeDTO.getQuantity(), chargeDTO.getNote());
    }

}
