package cn.rankin.userservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.ShopCartDTO;
import cn.rankin.data.api.user.entity.BuyMsg;
import cn.rankin.data.api.user.entity.ShopCart;
import cn.rankin.userservice.service.BuyMsgService;
import cn.rankin.userservice.service.ShopCartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/shopcart")
public class ShopCartController {

    @Autowired
    private ShopCartService shopCartService;

    @Autowired
    private BuyMsgService buyMsgService;

    @RequestMapping(value = "/list", method = RequestMethod.POST)
    public APIResult<List<ShopCart>> findByIds(@RequestBody List<String> goodsIdList, @RequestParam("userId") String userId) {
        return shopCartService.findByIds(userId, goodsIdList);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Boolean> add(@RequestBody ShopCartDTO shopCartDTO) {
        return shopCartService.add(shopCartDTO.getUserId(), shopCartDTO.getGoodsId(), shopCartDTO.getPid());
    }

    @RequestMapping(method = RequestMethod.GET)
    public APIResult<Page<ShopCart>> getPage(@RequestParam("userId") String userId, @RequestParam("pageNo") Integer pageNo,
                                             @RequestParam("pageSize") Integer pageSize) {
        return shopCartService.getPage(userId, pageNo, pageSize);
    }

    @RequestMapping(method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@RequestParam("userId") String userId, @RequestParam("goodsId") String goodsId) {
        return shopCartService.delete(userId, goodsId);
    }

    @RequestMapping(value = "/totalNum", method = RequestMethod.GET)
    public APIResult getTotalNum(@RequestParam("userId") String userId) {
        return shopCartService.getTotalNum(userId);
    }

    @RequestMapping(value = "/buymsg", method = RequestMethod.POST)
    public APIResult<Boolean> push(@RequestParam("userId") String userId) {
        return buyMsgService.push(userId);
    }

    @RequestMapping(value = "/buymsg", method = RequestMethod.GET)
    public APIResult<List<BuyMsg>> get(@RequestParam("userId") String userId) {
        return buyMsgService.get(userId);
    }

    @RequestMapping(value = "/buymsg", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@RequestParam("userId") String userId) {
        return buyMsgService.delete(userId);
    }
}
