package cn.rankin.userservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.auth.dto.AuthQueryDTO;
import cn.rankin.data.api.auth.vo.AuthVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class RemoteAuthProxy {

    @Autowired
    private RemoteAuthFeign remoteAuthFeign;

    public Page<AuthVo> findAuthList(AuthQueryDTO authQueryDTO) {
        APIResult<Page<AuthVo>> apiResult = remoteAuthFeign.findAuthList(authQueryDTO);
        if(!apiResult.getSuccess()){
            throw new RuntimeException("远程服务器错误");
        }
        return apiResult.getData();
    }
}
