package cn.rankin.userservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.Campus;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface CampusRepository extends BasicJpaRepository<Campus, String> {

    @Query(value = "select max(c.serialNo) from Campus c where c.merchantId = :merchantId and c.provinceCode = :provinceCode")
    Integer findMaxNo(@Param("merchantId") String merchantId, @Param("provinceCode") String proviceCode);

    List<Campus> findByNameLike(String name);

}
