package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.CmsUser;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;


@Repository
public interface CmsUserRepository extends BasicJpaRepository<CmsUser, String> {

    List<CmsUser> findByIdInAndStatus(Collection<Long> ids, BaseStatusEnum status);

    CmsUser findByNameAndStatus(String name, BaseStatusEnum status);

    @Modifying
    @Query(value = "update CmsUser u set u.status = :status where u.id = :id")
    Integer updateStatusById(@Param("id") String id, @Param("status") BaseStatusEnum status);
}
