package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.Merchant;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.List;

@Repository
public interface MerchantRepository  extends BasicJpaRepository<Merchant, String> {

    Long countByCode(String code);

	Merchant findByIdAndStatus(String id, BaseStatusEnum status);

	Merchant findByName(String name);

	@Modifying
    @Query("update Merchant m set m.status = :status where m.id = :id ")
    int updateStatusById(@Param("id") String id, @Param("status") BaseStatusEnum status);

	@Modifying
    @Query(value = "update Merchant m set m.balance = m.balance + ?2 where m.balance + ?2 > 0 and m.id = ?1")
    Integer updateBalance(String merchantId, BigDecimal quantity);
}
