package cn.rankin.userservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.ShopCart;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface ShopCartRepository extends BasicJpaRepository<ShopCart, String> {

    @Query(value = "select s from ShopCart s where s.goodsId in (?1) and s.userId = ?2 and s.status = 0")
    List<ShopCart> findByGoodsIds(List<String> goodsIdList, String userId);

    @Modifying
    @Query(value = "update ShopCart s set s.status = 1 where s.userId = ?1 and s.goodsId = ?2")
    Integer deleteByUserIdAndGoodsId(String userId, String goodsId);

    @Modifying
    @Query(value = "update ShopCart s set s.status = 1 where s.userId = ?1")
    Integer deleteByUserId(String userId);
}
