package cn.rankin.userservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.TerminalDevice;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface TerminalDeviceRepository extends BasicJpaRepository<TerminalDevice, String> {

    List<TerminalDevice> findByDeviceCode(String code);

    TerminalDevice findByUserId(String userId);

    TerminalDevice findByDeviceCodeOrUserId(String code, String userId);

    @Modifying
    Integer deleteByUserId(String userId);

    @Modifying
    Integer deleteByDeviceCodeAndMerchant(String code, String merchant);

}
