package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.TerminalUser;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface TerminalUserRepository extends BasicJpaRepository<TerminalUser, String> {

    @Query(value = "select max(t.serialNo) from TerminalUser t where t.campusId = :campusId")
    Integer findMaxNo(@Param("campusId") String campusId);

    List<TerminalUser> findByCampusIdIn(List<String> campusIds);

    TerminalUser findByCode(String code);

    @Modifying
    @Query(value = "update TerminalUser t set t.status = :status where t.id = :id")
    Integer updateStatusById(@Param("status") BaseStatusEnum status, @Param("id") String id);
}
