package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.UserRecommend;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface UserRecommendRepository extends BasicJpaRepository<UserRecommend, String> {

    @Query(value = "select r from UserRecommend r where r.uid = :uid and r.status = :status order by r.sort")
    List<UserRecommend> findByStatus(@Param("uid") String uid, @Param("status") BaseStatusEnum status);

    List<UserRecommend> findByUid(String uid);
}
