package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.UserTagProductRelation;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface UserTagProductRelationRepository extends BasicJpaRepository<UserTagProductRelation, String> {

    @Query(value = "select r from UserTagProductRelation r where r.tagId = ?1 and r.status = ?2 order by r.sort")
    List<UserTagProductRelation> findByTagId(String tagId, BaseStatusEnum status);

    List<UserTagProductRelation> findByTagId(String tagId);

    @Modifying
    @Query(value = "update UserTagProductRelation r set r.status = 1 where r.tagId = :tagId")
    Integer deleteByTagId(@Param("tagId") String tagId);

/*
    @Modifying
    @Query(value = "update UserTagProductRelation r set r.status = 1 where r.pid = :productId and r.tagId = :tagId")
    Integer deleteByPidAndTagId(@Param("productId") String productId, @Param("tagId") String tagId);

    List<UserTagProductRelation> findByTagIdIn(List<String> tagIds);

    @Query(value = "select r from UserTagProductRelation r where r.pid in (?1) and r.tagId in (?2) and r.status = 0")
    List<UserTagProductRelation> findByPidsAndTagIds(List<String> pids, List<String> tagIds);

    @Query(value = "select r from UserTagProductRelation r where r.pid = ?1 and r.tagId = ?2 and r.status = ?3")
    List<UserTagProductRelation> findByPidAndTagId(String pid, String tagId, BaseStatusEnum status);

    List<UserTagProductRelation> findByPidAndTagId(String pid, String merchantId);

    @Query(value = "select r from UserTagProductRelation r where r.tagId = ?1 and r.pid in (?2) and r.status = 0 order by r.sort limit ?3, ?4", nativeQuery = true)
    List<UserTagProductRelation> findByTagIdAndPids(String tagId, List<String> productIdList, Long start, Integer size);
*/

}
