package cn.rankin.userservice.service;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.data.api.user.dto.EventLogDTO;
import cn.rankin.data.api.user.entity.EventLog;
import cn.rankin.userservice.repository.EventLogRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

import static cn.rankin.userservice.utils.DTOConverter.convert;

@Service
public class EventLogService {

    @Autowired
    private EventLogRepository eventLogRepository;

    public APIResult<Boolean> addLog(EventLogDTO eventLogDTO) {
        EventLog eventLog = convert(eventLogDTO);
        eventLogRepository.save(eventLog);
        return APIResult.ok(Boolean.TRUE);
    }

    public List<EventLog> findEventLogs(String uid) {
        return eventLogRepository.findEventLogs(uid);
    }
}
