package cn.rankin.userservice.service;

import cn.rankin.common.utils.enums.LedgerTypeEnum;
import cn.rankin.data.api.user.entity.Ledger;
import cn.rankin.userservice.repository.LedgerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.math.BigDecimal;

@Service
public class LedgerService {

    @Autowired
    private LedgerRepository ledgerRepository;

    @Transactional
    public void insert(String merchantId, BigDecimal quantity, BigDecimal balanceBefore,
                       LedgerTypeEnum type, String receiptId, String note) {
        Ledger ledger = new Ledger(merchantId, balanceBefore, quantity, type, receiptId, note);
        ledgerRepository.save(ledger);
    }

}
